/////////////////////////////////////
//  Generated Initialization File  //
/////////////////////////////////////

#include "C8051F000.h"

// Peripheral specific initialization functions,
// Called from the Init_Device() function
void Reset_Sources_Init()
{
    WDTCN     = 0xDE;
    WDTCN     = 0xAD;
}

void Timer_Init()
{
    TMR3RLL   = 0xB4;
    TMR3RLH   = 0xE2;
    TMR3L     = 0xB4;
    TMR3H     = 0xE2;
}

void ADC_Init()
{
    ADC0CN    = 0xC0;
}

void Voltage_Reference_Init()
{
    REF0CN    = 0x03;
}

void Port_IO_Init()
{
    // P0.0  -  Unassigned,  Push-Pull   
    // P0.1  -  Unassigned,  Push-Pull   
    // P0.2  -  Unassigned,  Push-Pull   
    // P0.3  -  Unassigned,  Push-Pull   
    // P0.4  -  Unassigned,  Push-Pull   
    // P0.5  -  Unassigned,  Open-Drain  
    // P0.6  -  Unassigned,  Open-Drain  
    // P0.7  -  Unassigned,  Open-Drain  

    PRT0CF    = 0x1F;
    XBR2      = 0x40;
}

void Oscillator_Init()
{
    int i = 0;
    OSCXCN    = 0x67;
    for (i = 0; i < 3000; i++);  // Wait 1ms for initialization
    while ((OSCXCN & 0x80) == 0);
    OSCICN    = 0x0C;
}

void Interrupts_Init()
{
    IE        = 0x80;
    EIE2      = 0x01;
}

// Initialization function for device,
// Call Init_Device() from your main program
void Init_Device(void)
{
    Reset_Sources_Init();
    Timer_Init();
    ADC_Init();
    Voltage_Reference_Init();
    Port_IO_Init();
    Oscillator_Init();
    Interrupts_Init();
}
